﻿Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim f As New FinanceFunctions.FinanceFunctions
        Dim call_price As Double = 0
        Dim put_price As Double = 0
        'Example: SPY is currently at 134.45, volatility at 20.1%, with a dividend of .60 per share
        'Note: We pass True for the American Flag since SPY is an American settled ETF.
        call_price = f.OptionPrice(True, "c", 134.45, 130, CDate("2/17/2012"), 0.01, 0.6, 0.201)
        put_price = f.OptionPrice(True, "p", 134.45, 130, CDate("2/17/2012"), 0.01, 0.6, 0.201)

        'Example SPY at 135, Strike:180, Demonstrates .60 per share dividend is priced correctly on DITM (Deep in the money) American options (the put has .60 cents added to the price DITM, the call has .60 cents subtracted):
        call_price = f.OptionPrice(True, "c", 135, 180, CDate("3/17/2012"), 0.01, 0.6, 0.18)
        put_price = f.OptionPrice(True, "p", 135, 180, CDate("3/17/2012"), 0.01, 0.6, 0.18)

        'Example: SPX (European settled) at 135, dividend 0, 18% volatility:
        call_price = f.OptionPrice(False, "c", 135, 180, CDate("3/17/2012"), 0.01, 0.0, 0.18)
        put_price = f.OptionPrice(False, "p", 135, 180, CDate("3/17/2012"), 0.01, 0.0, 0.18)

        Debug.Print("Call Price: " + Trim(call_price))
        Debug.Print("Put Price: " + Trim(put_price))

        'Example: Calculate the price of a one year 160 PUT Calendar on SPY assuming 21% volatility and UL is at 135
        Dim put_calendar_price As Double = 0
        Dim leg1 As Double = 0
        Dim leg2 As Double = 0
        'Note: The reason I used a .35 cent dividend on SPY, is I found the closer you get to the money the dividend is priced in less.  This is the happy medium I used to reconcile the price to the real time calendar spread.

        leg1 = f.OptionPrice(True, "p", 134, 160, CDate("12/25/2012"), 0.015, 0.35, 0.24)
        leg2 = f.OptionPrice(True, "p", 134, 160, CDate("12/25/2013"), 0.015, 0.35, 0.24)
        put_calendar_price = leg2 - leg1
        MsgBox("Put Calendar price: " + Trim(put_calendar_price))
        Dim call_calendar_price As Double = 0

        leg1 = f.OptionPrice(True, "c", 134, 160, CDate("12/25/2012"), 0.01, 0.35, 0.24)
        leg2 = f.OptionPrice(True, "c", 134, 160, CDate("12/25/2013"), 0.01, 0.35, 0.24)
        call_calendar_price = leg2 - leg1

      

        leg1 = f.OptionPrice(True, "p", 134, 160, CDate("12/25/2013"), 0.015, 0.35, 0.24)
        leg2 = f.OptionPrice(True, "p", 134, 160, CDate("12/25/2014"), 0.015, 0.35, 0.24)
        put_calendar_price = leg2 - leg1

        MsgBox(Trim(put_calendar_price))






    End Sub
End Class
